unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm2 = class(TForm)
    Button1: TButton;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Label1: TLabel;
    Edit1: TEdit;
    GroupBox2: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Edit2: TEdit;
    GroupBox3: TGroupBox;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}
  uses Unit1;

procedure TForm2.FormShow(Sender: TObject);
var
  i,j,k,l: Integer;
begin
  Canvas.Pen.Color := clBlack;
  Canvas.DrawFocusRect(Rect(40,10,1320,410));
  Canvas.TextOut(35,415,'1');
  Canvas.MoveTo(40,210);
  Canvas.LineTo(1320,210);
  j := 50;
  k := 2;
  l := 3;
  for i := 1 to 127 do
    begin
      Canvas.MoveTo(j,10);
      if (l = 6) then
        begin
        Canvas.LineTo(j,420);
        l := 1;
        end
      else
        Canvas.LineTo(j,410);

      Canvas.LineTo(j,410);
      if (k = 6) then
        begin
          k := 1;
          Canvas.TextOut((j-12),415,IntToStr(i));
        end;
      j := j + 10;
      k := k + 1;
      l := l + 1;
    end;
end;

procedure TForm2.Button1Click(Sender: TObject);
var
  i,j,k,l,m,x,y,x_base: Integer;
  tmp_str: String;
  hex_int1, hex_int2: Integer;
  hex_str1: char;
  hex_str2: String;

begin
  // Draw frame
  Canvas.Pen.Color := clBlack;
  Canvas.Pen.Width := 1;
  Canvas.DrawFocusRect(Rect(40,10,1320,410));
  Canvas.TextOut(35,415,'1');
  Canvas.MoveTo(40,210);
  Canvas.LineTo(1320,210);
  j := 50;
  k := 2;
  l := 3;
  x_base := 210;
  Canvas.TextOut(20,(x_base - 128*StrToInt(Edit1.Text)),'128');
  Canvas.TextOut(20,(x_base - 64*StrToInt(Edit1.Text)),'64');
  Canvas.TextOut(20,(x_base - 32*StrToInt(Edit1.Text)),'32');
  Canvas.TextOut(20,(x_base + 32*StrToInt(Edit1.Text)),'-32');
  Canvas.TextOut(20,(x_base + 64*StrToInt(Edit1.Text)),'-64');
  Canvas.TextOut(20,(x_base + 128*StrToInt(Edit1.Text)),'-128');
  for i := 1 to 127 do
    begin
      Canvas.MoveTo(j,10);
      if (l = 6) then
        begin
        Canvas.LineTo(j,420);
        l := 1;
        end
      else
        Canvas.LineTo(j,410);

      Canvas.LineTo(j,410);
      if (k = 6) then
        begin
          k := 1;
          Canvas.TextOut((j-12),415,IntToStr(i));
        end;
      j := j + 10;
      k := k + 1;
      l := l + 1;
    end;

  // Draw spectrum
  x_base := 210;
  Canvas.Pen.Width := 2;
  if (RadioButton3.Checked = True) then   // Plot data for FFT
    begin
      if (RadioButton1.Checked = True) then // Input data to be plotted
        begin
          if (CheckBox1.Checked = True) then
            begin
              j := 40;
              Canvas.Pen.Color := clRed;  // Real spectrum is drawn in red
              Canvas.MoveTo(j,(x_base - round(fft_r[1] * StrToInt(Edit1.Text))));
              for i := 2 to 128 do
                begin
                  j := j + 10;
                  Canvas.LineTo(j,(x_base - round(fft_r[i] * StrToInt(Edit1.Text))));
                end;
            end;
          if (CheckBox2.Checked = True) then
            begin
              j := 40;
              Canvas.Pen.Color := clBlue;   // Imaginary spectrum is drawn in blue
              Canvas.MoveTo(j,(x_base - round(fft_i[1] * StrToInt(Edit1.Text))));
              for i := 2 to 128 do
                begin
                  j := j + 10;
                  Canvas.LineTo(j,(x_base - round(fft_i[i] * StrToInt(Edit1.Text))));
                end;
            end;
        end
      else
        begin         // Data acquired from SP605 to be displayed
        // Data in char form aqcquired from SP605 is stored in array buf
        // These are 32-bit words.
        // Even 32-bit words represent real part of spectrum - to be confirmed?
        // Odd 32-bit words represent imaginary part of spectrum - to be confirmed?
          if (CheckBox1.Checked = True) then    // Draw real part of spectrum
            begin
              j := 40;
              Canvas.Pen.Color := clRed;
              tmp_str := '';
              for i := 1 to 7 do
                begin
                  if (i > 2) then     // Strip only 5 LSB
                    tmp_str := tmp_str + buf[i];
                  if (i = 3) then
                    hex_str1 := buf[i]; // This symbol is sign indicator
                end;
              hex_str2 := Form1.HexToBinStr(hex_str1);
              if (hex_str2[3] = '1') then   // Negative number
                begin
                  hex_int1 := 1 - (StrToInt('0x40000') - StrToInt('0x' + tmp_str));
                end
              else
                begin      // Positive number
                  hex_int1 := StrToInt('0x' + tmp_str);
                end;
 //             Form1.Memo1.Lines.Add(IntToStr(hex_int1) + '      ' + tmp_str);

              Canvas.MoveTo(j,(x_base - round(hex_int1*0.001953125*StrToInt(Edit1.Text))));
              m := 16;
              for k := 2 to 128 do
                begin
                  j := j + 10;
                  tmp_str := '';
                  for i := 1 to 7 do
                    begin
                      if (i > 2) then        // Strip only 5 LSB
                        tmp_str := tmp_str + buf[i+m];
                      if (i = 3) then
                        hex_str1 := buf[i+m];     // This symbol is sign indicator
                    end;
                  hex_str2 := Form1.HexToBinStr(hex_str1);
                  if (hex_str2[3] = '1') then       // Negative number
                    hex_int1 := 1 - (StrToInt('0x40000') - StrToInt('0x' + tmp_str))
                  else
                    hex_int1 := StrToInt('0x' + tmp_str);
                  Canvas.LineTo(j,(x_base - round(hex_int1*0.001953125*StrToInt(Edit1.Text))));
   //               Form1.Memo1.Lines.Add(IntToStr(hex_int1) + '      ' + tmp_str + '     ' + hex_str2 + '      ' + hex_str2[1] + hex_str2[2] + hex_str2[3] + hex_str2[4]);
                  m := m + 16;
                end;
            end;

          if (CheckBox2.Checked = True) then  // Draw imaginary part of spectrum
            begin
              j := 40;
              Canvas.Pen.Color := clBlue;
              tmp_str := '';
              for i := 8 to 15 do
                begin
                  if (i > 10) then                  
                    tmp_str := tmp_str + buf[i];
                  if (i = 11) then
                    hex_str1 := buf[i];
                end;
              hex_str2 := Form1.HexToBinStr(hex_str1);
              if (hex_str2[3] = '1')  then
                hex_int1 := 1 - (StrToInt('0x40000') - StrToInt('0x' + tmp_str))
              else
                hex_int1 := StrToInt('0x' + tmp_str);
  //            Form1.Memo1.Lines.Add(tmp_str + '     ' + hex_str2 + '      ' + IntToStr(hex_int1));
              Canvas.MoveTo(j,(x_base - round(hex_int1*0.001953125*StrToInt(Edit1.Text))));
              m := 16;
              for k := 2 to 128 do
                begin
                  j := j + 10;
                  tmp_str := '';
                  for i := 8 to 15 do
                    begin
                      if (i > 10) then                      
                        tmp_str :=  tmp_str + buf[i+m];
                      if (i = 11) then
                        hex_str1 := buf[i+m];
                    end;
                  hex_str2 := Form1.HexToBinStr(hex_str1);
                  if (hex_str2[3] = '1') then
                    hex_int1 := 1 - (StrToInt('0x40000') - StrToInt('0x' + tmp_str))
                  else
                    hex_int1 := StrToInt('0x' + tmp_str);
                  Canvas.LineTo(j,(x_base - round(hex_int1*0.001953125*StrToInt(Edit1.Text))));
                  m := m + 16;
                end;
            end;
        end;
    end
  else        // Plot IFFT data
    begin
      if (RadioButton1.Checked = True) then // Input data to be plotted
        begin
          if (CheckBox1.Checked = True) then
            begin
              j := 40;
              Canvas.Pen.Color := clRed;  // Real spectrum is drawn in red
              Canvas.MoveTo(j,(x_base - round(ifft_r[1] * StrToInt(Edit1.Text))));
              for i := 2 to 128 do
                begin
                  j := j + 10;
                  Canvas.LineTo(j,(x_base - round(ifft_r[i] * StrToInt(Edit1.Text))));
                end;
            end;
          if (CheckBox2.Checked = True) then
            begin
              j := 40;
              Canvas.Pen.Color := clBlue;   // Imaginary spectrum is drawn in blue
              Canvas.MoveTo(j,(x_base - round(ifft_i[1] * StrToInt(Edit1.Text))));
              for i := 2 to 128 do
                begin
                  j := j + 10;
                  Canvas.LineTo(j,(x_base - round(ifft_i[i] * StrToInt(Edit1.Text))));
                end;
            end;
        end
      else
        begin         // Data acquired from SP605 to be displayed
        // Data in char form aqcquired from SP605 is stored in array buf
        // These are 32-bit words.
        // Even 32-bit words represent real part of spectrum - to be confirmed?
        // Odd 32-bit words represent imaginary part of spectrum - to be confirmed?
          if (CheckBox1.Checked = True) then    // Draw real part of spectrum
            begin
              j := 40;
              Canvas.Pen.Color := clRed;
              tmp_str := '';
              for i := 1 to 8 do
                begin
                  tmp_str := tmp_str + buf[i];
                end;
              Canvas.MoveTo(j,(x_base - round((StrToInt('0x' + tmp_str)*StrToInt(Edit1.Text)))));
              m := 16;
              for k := 2 to 128 do
                begin
                  j := j + 10;
                  tmp_str := '';
                  for i := 1 to 8 do
                    begin
                      tmp_str := tmp_str + buf[i+m];
                    end;
                  Canvas.LineTo(j,(x_base - round((StrToInt('0x' + tmp_str)*StrToInt(Edit1.Text)))));
                  m := m + 16;
                end;
            end;

          if (CheckBox2.Checked = True) then  // Draw imaginary part of spectrum
            begin
              j := 40;
              Canvas.Pen.Color := clBlue;
              tmp_str := '';
              for i := 9 to 16 do
                begin
                  tmp_str := tmp_str + buf[i];
                end;
              Canvas.MoveTo(j,(x_base - round((StrToInt('0x' + tmp_str)*StrToInt(Edit1.Text)))));
              m := 16;
              for k := 2 to 128 do
                begin
                  j := j + 10;
                  tmp_str := '';
                  for i := 9 to 16 do
                    begin
                      tmp_str :=  tmp_str + buf[i+m];
                    end;
                  Canvas.LineTo(j,(x_base - round((StrToInt('0x' + tmp_str)*StrToInt(Edit1.Text)))));
                  m := m + 16;
                end;
            end;
        end;
    end;     // End of IFFT plot data

end;

end.
