//==================================================
//--------- Programmed by Alexey Grebennikov--------
//-------- alexey.grebennikov@bakerhughes.com-------
//==================================================
//
// Parameters file for the module wb_host.v
//
// States of WBHOST FSM
  `define WBHOST_IDLE     4'b0000                 // WB host is idle - no R/W accesses
  `define WBHOST_UART     4'b0001                 // WB bus is being accessed by the UART controller
  `define WBHOST_FFT      4'b0010                 // WB bus is being accessed by FFT core
  
// Base addresses ofo various devices
  `define BASE_UART     20'h00001                 // Base address of UART is 32'h00001000
  `define BASE_FFT      20'h00008                 // Base address of FFT core is 32'h00008000
